#include "util.h"

using namespace dpp;

#define SR_IMAGE "https://i.imgur.com/MV4i9oF.png"

uint32_t util::getHexColor(EmbedType type) {
    switch (type) {
        case ERROR:
            return 0xde1f1f;
        case SUCCESS:
            return 0x2ecc71;
        case INFO:
            return 0x748AD6;
    }
}

embed util::getDefaultEmbed(EmbedType type) {
    embed e;
    e.set_footer("Sheepstar", SR_IMAGE);
    e.set_timestamp(time(nullptr));
    e.set_color(getHexColor(type));
    return e;
}

sql::Connection *util::createConnection(const json &config) {
    sql::Driver *driver = sql::mariadb::get_driver_instance();

    sql::SQLString url = "jdbc:" + config["string"].get<std::string>();

    sql::Properties properties({{"user",     config["username"].get<std::string>()},
                                {"password", config["password"].get<std::string>()},
                                {"autoReconnect",   "true"},
                                {"maxReconnects",   "500"}});

    sql::Connection *con = driver->connect(url, properties);
    return con;
}