#include "ready.h"

const std::chrono::seconds statusChangeInterval(15);

std::thread ready::get_status_thread(dpp::cluster &bot) {
    return std::thread([&bot]() {
        while (true) {
            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_watching, "support.sheepstar.xyz"));
            std::this_thread::sleep_for(statusChangeInterval);

            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_listening, "/help"));
            std::this_thread::sleep_for(statusChangeInterval);

            bot.set_presence(dpp::presence(dpp::ps_online, dpp::at_watching, "sheepstar.xyz"));
            std::this_thread::sleep_for(statusChangeInterval);
        }
    });
}

void ready::execute(dpp::cluster &bot, const dpp::ready_t &event) {
    std::cout << "Logged in as " << bot.me.username << " (" << bot.me.id << ")"
              << std::endl;

    std::thread status_thread = get_status_thread(bot);
    status_thread.detach();

    if (dpp::run_once<struct register_bot_commands>()) {
        bot.global_command_create(dpp::slashcommand("rules", "Shows you the rules of the global chat", bot.me.id));
    }
}
